#!/bin/sh
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 

SLIBINFO="/usr/local/lib/Sscripts/libinfo.3"
SNAME="maj_lftp.sh"
SVER="16 oct 2001"
SDESC="Manage updating website with ftp protocol"
SREQUIRE="lftp, environment variables set see source"


#### VARIABLE THAT NEEDS TO BE SETTED
## $MAJLFTP_USERPASS="user,pass"
## $MAJLFTP_REMOTEHTDOCS="ftp.server.org/htdocs"
## $MAJLFTP_LOCALHTDOCS="/home/user/website/htdocs"

# conf

NET_CONNECTION="ppp0"
COMMAND_LIST="$HOME/.$SNAME-commandlist"
DIR="$2"
FILE="$3"

# functions

    # infos
    function help {
	echo "WARNING: THIS IS AN OLD SCRIPT, He will be rewrited soon"
	echo "Usage :  $SNAME.sh OPTION"
	echo "$SDESC"
	echo ""
	echo "  -a, --add                  add an new file to upload, (should be like -a folder file)"
	echo "  -u, --update               update"
	echo "  -e, --edit                 edit command list with $EDITOR"
	echo "  -s, --show                 show command list"
	echo "  -r, --rm                   remove command list"
        echo "  -v, --version              output version information and exit"
	echo ""
	if [ "$SREQUIRE" != "" ]; then echo "To use this script, you need $SREQUIRE" ; fi
	echo "Report bugs or suggestions to <yeupou@coleumes.org>"
    }
    
    function version { 
	$SLIBINFO "$SNAME" "$SVER" "$SDESC" "$SREQUIRE"
    }

    # work
    function add {
	touch $COMMAND_LIST
	# vrifie que l'entre n'existe pas dj
	VERIF="`cat $COMMAND_LIST | grep $DIR/$FILE`"
	if [ "$VERIF" != "# $DIR/$FILE" ] ; then
	    echo "# `date +%x\ %X`" >> $COMMAND_LIST
	    echo "# $DIR/$FILE" >> $COMMAND_LIST
	    echo "echo $DIR:$FILE" >> $COMMAND_LIST
	    echo "cd $MAJLFTP_LOCALHTDOCS/$DIR && lftp -u $MAJLFTP_USERPASS -e \"put $FILE && exit\" $MAJLFTP_REMOTEHTDOCS/$DIR"  >> $COMMAND_LIST
	fi
    }
    function connexion_test {
        if ! /sbin/ifconfig $NET_INTERFACE > /dev/null 2>&1 ; then
	    echo "No connection on $NET_INTERFACE" 
	    exit
	fi
    }
    function update {
	connexion_test
	chmod +x $COMMAND_LIST
        $COMMAND_LIST
	rmcl
    }
    function edit {
	if [ "$EDITOR" != "" ] ; then
	    $EDITOR $COMMAND_LIST
	else
	    emacs $COMMAND_LIST
	fi
    }
    function show {
	cat $COMMAND_LIST
    }
    function rmcl {
	rm -f $COMMAND_LIST
    }


# go !

case $1 in
	--version | -v ) version ;;
	--add | -a ) add ;;
	--update | -u ) update ;;
	--edit | -e ) edit;;
	--show | -s ) show;;
	--rm | -r ) rmcl ;;
	* ) help ;;
esac

# end