#!/bin/sh
#
# Part of TUI-SH
# (c) 2001-2002 Mathieu Roy <yeupou@gnu.org>
#
#  see http://fs.fsf.org/projects/tui-sh
#  comments to <tui-sh-dev@mail.freesoftware.fsf.org>
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# $Id: libinfo.5.sh,v 1.2 2002/08/05 06:57:22 yeupou Exp $
#

function TUISH_help {
        echo "Usage : $TUISH_NAME $TUISH_USAGE"
	echo "$TUISH_DESC"
	echo ""
        echo "  -h, --help                 display this help and exit"
        echo "      --version              output version information and exit"
	if [ "$TUISH_HELP_00" != "" ]; then echo "$TUISH_HELP_00" ; fi
	if [ "$TUISH_HELP_01" != "" ]; then echo "$TUISH_HELP_01" ; fi
	if [ "$TUISH_HELP_02" != "" ]; then echo "$TUISH_HELP_02" ; fi
	if [ "$TUISH_HELP_03" != "" ]; then echo "$TUISH_HELP_03" ; fi
	if [ "$TUISH_HELP_04" != "" ]; then echo "$TUISH_HELP_04" ; fi
	if [ "$TUISH_HELP_05" != "" ]; then echo "$TUISH_HELP_05" ; fi
	if [ "$TUISH_HELP_06" != "" ]; then echo "$TUISH_HELP_06" ; fi
	if [ "$TUISH_HELP_07" != "" ]; then echo "$TUISH_HELP_07" ; fi
	if [ "$TUISH_HELP_08" != "" ]; then echo "$TUISH_HELP_08" ; fi
	if [ "$TUISH_HELP_09" != "" ]; then echo "$TUISH_HELP_09" ; fi
	if [ "$TUISH_HELP_10" != "" ]; then echo "$TUISH_HELP_10" ; fi
	if [ "$TUISH_HELP_11" != "" ]; then echo "$TUISH_HELP_11" ; fi
	if [ "$TUISH_HELP_12" != "" ]; then echo "$TUISH_HELP_12" ; fi
	if [ "$TUISH_HELP_13" != "" ]; then echo "$TUISH_HELP_13" ; fi
	if [ "$TUISH_HELP_14" != "" ]; then echo "$TUISH_HELP_14" ; fi
	if [ "$TUISH_HELP_15" != "" ]; then echo "$TUISH_HELP_15" ; fi
	if [ "$TUISH_HELP_16" != "" ]; then echo "$TUISH_HELP_16" ; fi
	if [ "$TUISH_HELP_17" != "" ]; then echo "$TUISH_HELP_17" ; fi
	if [ "$TUISH_HELP_18" != "" ]; then echo "$TUISH_HELP_18" ; fi
	if [ "$TUISH_HELP_19" != "" ]; then echo "$TUISH_HELP_19" ; fi
	if [ "$TUISH_HELP_20" != "" ]; then echo "$TUISH_HELP_20" ; fi
	if [ "$TUISH_HELP_21" != "" ]; then echo "$TUISH_HELP_21" ; fi
	if [ "$TUISH_HELP_22" != "" ]; then echo "$TUISH_HELP_22" ; fi
	if [ "$TUISH_HELP_23" != "" ]; then echo "$TUISH_HELP_23" ; fi
	if [ "$TUISH_HELP_24" != "" ]; then echo "$TUISH_HELP_24" ; fi
	if [ "$TUISH_HELP_25" != "" ]; then echo "$TUISH_HELP_25" ; fi
	if [ "$TUISH_HELP_26" != "" ]; then echo "$TUISH_HELP_26" ; fi
	if [ "$TUISH_HELP_27" != "" ]; then echo "$TUISH_HELP_27" ; fi
	if [ "$TUISH_HELP_28" != "" ]; then echo "$TUISH_HELP_28" ; fi
	if [ "$TUISH_HELP_29" != "" ]; then echo "$TUISH_HELP_29" ; fi
	if [ "$TUISH_HELP_30" != "" ]; then echo "$TUISH_HELP_30" ; fi
	if [ "$TUISH_HELP_31" != "" ]; then echo "$TUISH_HELP_31" ; fi
	if [ "$TUISH_HELP_32" != "" ]; then echo "$TUISH_HELP_32" ; fi
	if [ "$TUISH_HELP_33" != "" ]; then echo "$TUISH_HELP_33" ; fi
	if [ "$TUISH_HELP_34" != "" ]; then echo "$TUISH_HELP_34" ; fi
	if [ "$TUISH_HELP_35" != "" ]; then echo "$TUISH_HELP_35" ; fi
	if [ "$TUISH_HELP_36" != "" ]; then echo "$TUISH_HELP_36" ; fi
	if [ "$TUISH_HELP_37" != "" ]; then echo "$TUISH_HELP_37" ; fi
	if [ "$TUISH_HELP_38" != "" ]; then echo "$TUISH_HELP_38" ; fi
	echo ""
	if [ "$TUISH_REQUIRE" != "" ]; then echo "To use this script, you need $TUISH_REQUIRE" ; fi
	echo "Report bugs or suggestions to <$TUISH_MAIL>"
	exit
}

function TUISH_version {
    echo "$TUISH_NAME - $TUISH_VER"
    echo ""
    echo "Copyright (c) $TUISH_AUTHOR <$TUISH_MAIL>"
    echo "This is free software; see the source for copying conditions.  There is NO warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE."
    exit
}

#######
# end